//+------------------------------------------------------------------+
//|                                      Heiken Ashi Ma Smoothed.mq4 |
//+------------------------------------------------------------------+
//|                                                      mod by Raff |
//|                                               2009 mod by mladen |
//|                                              tools made it lines |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008,Forex-TSD.com"
#property link      "http://www.forex-tsd.com/"

#property indicator_chart_window
#property indicator_buffers 4   
#property indicator_color1  Pink
#property indicator_color2  SkyBlue
#property indicator_color3  Yellow 
#property indicator_color4  Red   


//
//
//
//
//

extern int             MaPeriod        = 5;
extern ENUM_MA_METHOD  MaMetod         = 2;
extern int             Step            = 1;
extern bool            BetterFormula   = true;
extern bool            alertsOn        = true;
extern bool            alertsOnCurrent = false;
extern bool            alertsMessage   = true;
extern bool            alertsSound     = true;
extern bool            alertsNotify    = false;
extern bool            alertsEmail     = false;
extern string          soundFile       = "alert2.wav";
extern bool            ShowArrows      = true;
extern int             arrowSize       = 2;
extern int             uparrowCode     = 233;
extern int             dnarrowCode     = 234;

//
//
//
//
//

double Buffer1[];
double Buffer2[];
double arrowUp[];
double arrowDn[];
double Buffer3[];
double Buffer4[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//|------------------------------------------------------------------|
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);   
   SetIndexBuffer(0,Buffer3); 
   SetIndexBuffer(1,Buffer4); 
   SetIndexBuffer(2,arrowUp);   
   SetIndexBuffer(3,arrowDn);     
   SetIndexBuffer(4,Buffer1); 
   SetIndexBuffer(5,Buffer2); 
   SetIndexBuffer(6,trend);
   
   if (ShowArrows)
   {
     SetIndexStyle(2,DRAW_ARROW,0,arrowSize); SetIndexArrow(2,uparrowCode);
     SetIndexStyle(3,DRAW_ARROW,0,arrowSize); SetIndexArrow(3,dnarrowCode);   
   }
   else
   {
     SetIndexStyle(2,DRAW_NONE);
     SetIndexStyle(3,DRAW_NONE);
   }       

return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int    counted_bars=IndicatorCounted();
   double pointModifier;
   int    pos,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-counted_bars,Bars-1);
         if (Digits==3 || Digits==5)
               pointModifier = 10;
         else  pointModifier = 1;               
          
   //
   //
   //
   //
   //
   
   for(pos=limit; pos >= 0; pos--)
   {
      double maOpen  = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_OPEN ,pos);
      double maClose = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_CLOSE,pos);
      double maLow   = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_LOW  ,pos);
      double maHigh  = iMA(NULL,0,MaPeriod,0,MaMetod,PRICE_HIGH ,pos);
      
      //
      //
      //
      //
      //
        
      if (BetterFormula) {
         if (maHigh!=maLow)
            double haClose = (maOpen+maClose)/2+(((maClose-maOpen)/(maHigh-maLow))*MathAbs((maClose-maOpen)/2));
         else      haClose = (maOpen+maClose)/2; }
         else      haClose = (maOpen+maHigh+maLow+maClose)/4;
            double haOpen  = (Buffer3[pos+1]+Buffer4[pos+1])/2;
            double haHigh  = MathMax(maHigh, MathMax(haOpen,haClose));
            double haLow   = MathMin(maLow,  MathMin(haOpen,haClose));

      if (haOpen<haClose) { Buffer1[pos]=haLow;  Buffer2[pos]=haHigh; } 
      else                { Buffer1[pos]=haHigh; Buffer2[pos]=haLow;  } 
                              Buffer3[pos]=haOpen;
                              Buffer4[pos]=haClose;
      
       //
       //
       //
       //
       //

       if (Step>0)
       {
         if(MathAbs(Buffer1[pos]-Buffer1[pos+1]) < Step*pointModifier*Point) Buffer1[pos]=Buffer1[pos+1];
         if(MathAbs(Buffer2[pos]-Buffer2[pos+1]) < Step*pointModifier*Point) Buffer2[pos]=Buffer2[pos+1];
         if(MathAbs(Buffer3[pos]-Buffer3[pos+1]) < Step*pointModifier*Point) Buffer3[pos]=Buffer3[pos+1];
         if(MathAbs(Buffer4[pos]-Buffer4[pos+1]) < Step*pointModifier*Point) Buffer4[pos]=Buffer4[pos+1];
       }         
       trend[pos] = trend[pos+1];
          if (Buffer3[pos] < Buffer4[pos]) trend[pos] =  1;
          if (Buffer3[pos] > Buffer4[pos]) trend[pos] = -1;  
          
          //
          //
          //
          //
          //
      
          arrowUp[pos] = EMPTY_VALUE;
          arrowDn[pos] = EMPTY_VALUE;
          if (trend[pos]!= trend[pos+1])
          if (trend[pos] == 1)
                arrowUp[pos] = Buffer3[pos] - iATR(NULL,0,20,pos)/2.0;
          else  arrowDn[pos] = Buffer4[pos] + iATR(NULL,0,20,pos)/2.0;  
    }
    
    //
    //
    //
    //
    //
    
    if (alertsOn)
    {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("crossing up");
      else  doAlert("crossing down");       
    }
return(0);
}

//
//
//
//
//

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
       if (previousAlert != doWhat || previousTime != Time[0]) {
           previousAlert  = doWhat;
           previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Heiken Ashi Smoothed Lines ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Heiken Ashi Smoothed Lines  "),message);
             if (alertsSound)   PlaySound(soundFile);
   }
}



